<?php
class YDygraphsExamples extends CWidget {
    public function init() {
    }
    public function run() {
        $sampleTimeSeries=new CJavaScriptExpression(
<<<EOJS
function(){
    var r=[];
    var base_time = Date.parse("2008/07/01");
    var num = 24 * 0.25 * 365;
    for (var i = 0; i < num; i++) {
        r.push([ new Date(base_time + i * 3600 * 1000),
         i + 50 * (i % 60),        // line
         i * (num - i) * 4.0 / num  // parabola
        ]);
    }
    return r;
}
EOJS
                    );
        
        $this->widget( "ext.YDygraphs.YDygraphs", array(
            'data'=>$sampleTimeSeries,
              'title'=>"Unzoom and Range selector",
              'rollPeriod'=> 7,
              'animatedZooms'=> true,
              'unzoom'=>true,
              'showRangeSelector'=>true,
              //'drawPoints'=>true,
              //'showRoller'=>true,
              // errorBars=> true,
              //'width'=> 600,
              //'height'=> 300,
              'labels'=> ["Date", "a", "b"],
            'htmlOptions'=>array('style'=>'width:100%;'),
            )
         );
     
        
        for($i=0;$i<2;$i++) {
            $this->widget( "ext.YDygraphs.YDygraphs", array(
                'title'=>"Synchronized $i",
                'legend'=>'always',
                'data'=>$sampleTimeSeries,
                'synchronizerId'=>'sync1',
                'unzoom'=>1,
                'rollPeriod'=> 7,
                //'animatedZooms'=> true,
                // errorBars=> true,
                'width'=> 400,
                'height'=> 300,
                //'labels'=> ["Date", "a", "b"]
            )
                    );
        }
        
        $highlightWeekendsUnderlay=<<<EOJS
    var canvas=arguments[0],area=arguments[1],g=arguments[2];
    canvas.fillStyle = "rgba(255, 255, 102, 1.0)";

    function highlight_period(x_start, x_end) {
      var canvas_left_x = g.toDomXCoord(x_start);
      var canvas_right_x = g.toDomXCoord(x_end);
      var canvas_width = canvas_right_x - canvas_left_x;
      canvas.fillRect(canvas_left_x, area.y, canvas_width, area.h);
    }

    var min_data_x = g.getValue(0,0);
    var max_data_x = g.getValue(g.numRows()-1,0);

    // get day of week
    var d = new Date(min_data_x);
    var dow = d.getUTCDay();

    var w = min_data_x;
    // starting on Sunday is a special case
    if (dow === 0) {
      highlight_period(w,w+12*3600*1000);
    }
    // find first saturday
    while (dow != 6) {
      w += 24*3600*1000;
      d = new Date(w);
      dow = d.getUTCDay();
    }
    // shift back 1/2 day to center highlight around the point for the day
    w -= 12*3600*1000;
    while (w < max_data_x) {
      var start_x_highlight = w;
      var end_x_highlight = w + 2*24*3600*1000;
      // make sure we don't try to plot outside the graph
      if (start_x_highlight < min_data_x) {
        start_x_highlight = min_data_x;
      }
      if (end_x_highlight > max_data_x) {
        end_x_highlight = max_data_x;
      }
      highlight_period(start_x_highlight,end_x_highlight);
      // calculate start of highlight for next Saturday 
      w += 7*24*3600*1000;
    }
EOJS;
        
        $this->widget( "ext.YDygraphs.YDygraphs", array(
            'data'=>$sampleTimeSeries,
            'underlayCallback'=>$highlightWeekendsUnderlay,
            'rollPeriod'=> 7,
            'animatedZooms'=> true,
            'unzoom'=>true,
            'showRangeSelector'=>true,
        
            // errorBars=> true,
            'width'=> 600,
            'height'=> 300,
            'labels'=> ["Date", "a", "b"]
        )
                );
        
    }
}